<template>
  <q-dialog v-model="persistent" content-class="bg-grey-1" transition-show="scale" transition-hide="scale">
    <q-card style="width: 800px;max-width:800px;">
      <q-card-section>
        <div class="text-h6">{{(saveObj&&saveObj.Id>0)?"修改值班事项":"新增值班事项"}}</div>
      </q-card-section>
      <q-card-section class="q-pt-none scroll" style="max-height: 70vh">
        <div class="row wrap">
          <div class="col-6">
            <q-input filled stack-label max-length="20" :dense="false" v-model="msg.ItemName" ref="ItemName"
              class="col-6 q-pr-lg q-pb-lg" label="事项名称" :rules="[val => !!val || '请填写事项名称']" />
          </div>
          <div class="col-6">
            <q-select stack-label color="primary" filled clearable label="选择事项类型" option-value="Id" option-label="Name"
              :options="itemTypeOptions" v-model="msg.ItemType" ref="ItemType" emit-value map-options :rules="[val => !!val || '请选择事项类型']" />
          </div>
        </div>
        <div class="row wrap">
          <div class="col-6">
            <q-select stack-label v-model="FrequencyArr" multiple :options="frequencyOptions" color="primary" filled
               label="选择班次" option-label="Name" option-value="Id" ref="Shifts"
              @input="getSchoolListByFrequencyIds" emit-value map-options :rules="[val => !!val || '请选择班次']" class="col-6 q-pr-lg q-pb-lg" />
          </div>
          <div class="col-6">
            <q-select stack-label v-model="schoolArr" multiple :options="schoolOptions" color="primary" filled
              label="选择校区" option-label="SName" option-value="SId" ref="ItemSchools"
              @input="getDutyFrequencyBySchoolIds" emit-value map-options :rules="[val => !!val || '请选择校区']" />
          </div>
        </div>
      </q-card-section>
      <q-card-actions align="right" class="bg-white">
        <q-btn label="取消" flat color="grey-10" style="font-weight:400 !important" @click="closeRuleForm" />
        <q-btn label="保存" color="accent q-px-md" style="font-weight:400 !important" @click="saveRule" />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
  import {
    saveDutyItem,
    queryDutyItemInfo,
    getSchoolListByFrequencyIds,
    getDutyFrequencyBySchoolIds,
    getItemTypeEnumList,
    getDutyFrequencyList,
  } from "../../api/duty/index"
  import {
    getSchoolDropdown
  } from '../../api/school/index'; //获取校区列表
  export default {
    props: {
      saveObj: {
        type: Object,
        default: null
      },
    },
    data() {
      return {
        itemArr: [],
        FrequencyArr: [], //多选班次列表
        schoolArr: [], //多选校区列表
        msg: {
          Id: 0,
          ItemName: "",
          ItemSchools: "",
          ItemType: 0,
          Shifts: ""
        },
        persistent: true,
        schoolOptions: [],
        frequencyOptions: [],
        itemTypeOptions: [],
      }
    },
    computed: {},
    created() {
      this.getCompanyList();
      this.getDutyFrequencyList();
      this.queryItemTypeEnumList();
    },
    mounted() {
      this.initObj();
    },
    methods: {
      initObj() {
        if (this.saveObj && this.saveObj.Id > 0) {
          queryDutyItemInfo({
            Id: this.saveObj.Id
          }).then(res => {
            if (res.Code == 1) {
              var tempData = res.Data;
              if (tempData) {
                this.msg.Id = tempData.Id;
                this.msg.ItemName = tempData.ItemName;
                this.msg.ItemSchools = tempData.ItemSchools;
                this.msg.ItemType = tempData.ItemType;
                this.msg.Shifts = tempData.Shifts;
                if (tempData.ShiftList && tempData.ShiftList.length > 0) {
                  this.FrequencyArr = tempData.ShiftList.map(i => i * 1);
                }
                if (tempData.SchoolList && tempData.SchoolList.length > 0) {
                  this.schoolArr = tempData.SchoolList.map(i => i * 1);
                }
              }
            }
          })
        } else {
          this.clearMsg();
        }
      },
      //获取值班事项类型枚举
      queryItemTypeEnumList() {
        getItemTypeEnumList({}).then(res => {
          if (res.Code == 1) {
            this.itemTypeOptions = res.Data;
          }
        })
      },
      //清空消息
      clearMsg() {
        this.msg.Id = 0;
        this.msg.ItemName = "";
        this.msg.ItemSchools = "";
        this.msg.ItemType = "";
        this.msg.Shifts = "";
      },
      //保存信息
      saveRule() {
        this.$refs.ItemName.validate();
        this.$refs.ItemType.validate();
        this.$refs.Shifts.validate();
        this.$refs.ItemSchools.validate();
        if (!this.$refs.ItemName.hasError &&
          !this.$refs.ItemType.hasError &&
          !this.$refs.Shifts.hasError &&
          !this.$refs.ItemSchools.hasError) {
          this.msg.ItemSchools = this.schoolArr.toString();
          this.msg.Shifts=this.FrequencyArr.toString();
          saveDutyItem(this.msg).then(res => {
            if (res.Code == 1) {
              this.clearMsg();
              this.$emit('success');
              this.closeRuleForm();
            }
          })
        }
      },
      //关闭窗口
      closeRuleForm() {
        this.$emit('close');
        this.persistent = false
      },
      //根据班次获取学校信息
      getSchoolListByFrequencyIds() {
        let Shifts = this.FrequencyArr.toString();
        getSchoolListByFrequencyIds({
          Shifts: Shifts
        }).then((res) => {
          this.schoolOptions = res.Data;
          this.schoolArr=[];
        })
      },
      //根据学校id获取对应的班次
      getDutyFrequencyBySchoolIds() {
        let SchoolIds = this.schoolArr.toString();
        getDutyFrequencyBySchoolIds({
          SchoolIds: SchoolIds
        }).then((res) => {
          this.frequencyOptions = res.Data
        })
      },
      //获取校区列表
      getCompanyList() {
        getSchoolDropdown({}).then(res => {
          if (res.Code == 1) {
            this.schoolOptions = res.Data;
          }
        })
      },
      //获取班次列表
      getDutyFrequencyList() {
        getDutyFrequencyList({}).then(res => {
          if (res.Code == 1) {
            this.frequencyOptions = res.Data;
          }
        })
      },
    },
  }

</script>
